unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ValEdit, ExtCtrls,
  Buttons;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnLoad: TBitBtn;
    btnCopy: TBitBtn;
    btnPaste: TBitBtn;
    Image1: TImage;
    Timer1: TTimer;
    procedure btnCopyClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure btnPasteClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation
uses clipbrd, lclintf, lcltype;

{$R *.lfm}

{ TForm1 }

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  btnPaste.Enabled := ClipBoard.HasPictureFormat;
end;

procedure TForm1.btnCopyClick(Sender: TObject);
var bmp1: TBitmap;
begin

  bmp1 := TBitmap.Create;

  bmp1.Width := Image1.Width;
  bmp1.Height := Image1.Height;
  bmp1.Canvas.Draw(0,0,Image1.Picture.Graphic);

  //Clipboard.Clear;
  Clipboard.Assign(bmp1);

  bmp1.Free;
end;

procedure TForm1.btnLoadClick(Sender: TObject);
begin
  ClipBoard.AsText := '';
end;

procedure TForm1.btnPasteClick(Sender: TObject);
var
  tempBitmap: TBitmap;
  PictureAvailable: boolean = False;

begin


  // we determine if any image is on clipboard
  if (Clipboard.HasFormat(PredefinedClipboardFormat(pcfBitmap))) then
    PictureAvailable := True;

  if PictureAvailable then
  begin


    tempBitmap := TBitmap.Create;

    if Clipboard.HasFormat(PredefinedClipboardFormat(pcfBitmap)) then
      tempBitmap.LoadFromClipboardFormat(PredefinedClipboardFormat(pcfBitmap));

    Image1.Width := tempBitmap.Width;
    Image1.Height := tempBitmap.Height;


    // this line does not resize the canvas
    // accordingly...
    //Image2.Canvas.Draw(0, 0, tempBitmap);


    // so we use assign, it works perfectly
    image1.Picture.Bitmap.Assign(tempBitmap);


    tempBitmap.Free;


  end
  else
  begin

    ShowMessage('No image is found on clipboard');

  end;end;

end.

